'*******************************************************************************
'  EERAM SETUP                         'SVN Rev.227 09.01.2011
'*******************************************************************************
'
'  Copyright bascom-forum.de (C) [2009]  [DON]
'  -> http://bascom-forum.de/index.php?topic=1781.new;topicseen#new
'  Software based on Code by Ben Zijlstra and Viktor Varga
'  Weiterentwickelt von
'    Huetti,
'    Michael
'    boeserkorn
'    mr_energy
'    HansHans
'    six1, Michael Kcher
'    dabuze                            datetime
'    framuel
'    tfv
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile

'*******************************************************************************
'  Update der Freesol-Werte
'*******************************************************************************
Sub Fs_freesol_update
   Local Svor As Integer
   Local Ltemp As Long
   Local Ltemp2 As Long
   Local Offs As Integer
   Local Offsmin As Integer
   Local Offsmin2 As Integer
   Local Offsmin3 As Integer
   Local Pzt As Long
   Local I As Integer
   Local J As Integer
   Local L As Long
   Local L2 As Long
   Local W As Word
   Local S2 As String * 10


#if Debug_freesol
    #if Fs_debugvar = 1
      If Fs_ersteraufruf = 0 Then
         Fs_ersteraufruf = 1                                ' Nur einmal ausfhren
         Print "Eprom-Werte von Freesol"
         Fs_eeram_lesen
      End If
    #endif
    #if Fs_debugvar = 2
       If Fs_ersteraufruf = 0 Then
         Fs_ersteraufruf = 1
         Fs_eeram_loeschen
         Print "Eprom-Werte von Freesol geloescht"
         Fs_eeram_lesen
       End If
    #endif
#endif


    If _year > 0 Then
      If Fs_ersteraufruf = 0 Then
         Fs_ersteraufruf = 1
         Fs_eeram_lesen
      End If
      Fs_tagesmax = 0
      For J = 10 To 0 Step -1                               '9
         L = Fs_speicherdatum_tage - J
         W = L
         S2 = Date(w)
         L2 = L Mod 100
         I = L2
         If Fs_tageswerte(i) > 0 Then
            Fs_tagesmax = J + 1
            J = 0
         End If
      Next J

      Offs = _hour + 1
      Pzt = Fs_pulszahl
      If Offs > 0 Then
         If Offs < 23 Then                                  ' Bei Stunde 24 wird das nicht mehr gemacht!
               Svor = Offs - 1
               Fs_stundenstart(offs) = Pzt
               If Svor = 0 Then
                  Ltemp = Fs_stundenstart(offs)
               Else
                  Ltemp = Fs_stundenstart(svor )
               End If
               Ltemp2 = Fs_stundenstart(offs )
               Fs_stundenwerte(offs) = Ltemp2 - Ltemp
         End If
      End If
      If Offs > 4 Then
         If Offs < 23 Then
            Ltemp = Fs_minlast
            Ltemp2 = Pzt
            Offsmin = _min
            Offsmin2 = Offsmin / 5
            Offsmin2 = Offsmin2 * 5
            #if Debug_freesol
             Print Offsmin2 ; "  " ; Offsmin ; "  " ; Ltemp2 ; "  " ; Ltemp
            #endif
            If Offsmin2 = Offsmin Then
               Offsmin2 = Offsmin / 5
               Fs_min_j = Offsmin2
               Offsmin3 = Offs - 5
               Fs_min_i = Offsmin3
               Offsmin3 = Offsmin3 * 12
               Offsmin3 = Offsmin3 + Offsmin2
               Fs_minlast = Ltemp2
               Ltemp2 = Ltemp2 - Ltemp
               Fs_minw(offsmin3) = Ltemp2
               Fs_akt_leist = Ltemp2 / 1000
               Fs_akt_leist = Fs_akt_leist * 12
               Fs_minpos = Offsmin3
            End If
         End If
      End If

      If Offs = 24 Then                                     '24 Vorschub um 23.45 Uhr
         If _min = 45 Then                                  '45
           ' Aktuellen Tag schreiben
            Fs_eeram_akt_tag_speich
         End If

      End If

      If Offs = 1 Then                                      '1 Booten nachts um 00.30
         If _min = 30 Then                                  '30
           ' Booten ber Watchdog
            Wait 10
         End If

      End If
   End If
End Sub


'*******************************************************************************
'  Freesol-Werte aus Eeram lesen
'*******************************************************************************
Sub Fs_eeram_lesen
   Local I As Integer
   Local L As Long
   Local L1 As Long
   Local L2 As Long
   Local D As Long


   Fs_anlagenleistung = Ee_fs_anlagenleistung

   If Fs_anlagenleistung = 0 Then
      Print "Fehler: Fs-anlagenleistung = 0"
   End If

   Fs_speicherdatum_tage = Ee_fs_speicherdatum_tage

   ' Hier wird ein mglicher fehler aus ungltigen (negativen) Fs_speicherdatum_tage abgefangen
   If Fs_speicherdatum_tage < 0 Then
      Fs_speicherdatum_tage = 0
      Ee_fs_speicherdatum_tage = Fs_speicherdatum_tage
   End If

   'Prfen, ob ungltige Werte im Eram vorliegen, und diese ggf berschreiben
   'Diese Routine ist ungetestet
   L = Sysday()
   L = L - 1

   If L > Fs_speicherdatum_tage Then                        ' Hier werden Vortage im Ringspeicher auf 0 gesetzt, falls an diesen kein Wert abgespeichert wurde
      L2 = L - Fs_speicherdatum_tage
      If L2 > 100 Then
         L2 = L - 100
      Else
         L2 = Fs_speicherdatum_tage + 1
      End If
      For L1 = L2 To L
          D = L1 Mod 100
          I = D
          Ee_fs_tageswerte(i) = 0
          Fs_tageswerte(i) = 0
      Next L1
      Fs_speicherdatum_tage = L
      Ee_fs_speicherdatum_tage = Fs_speicherdatum_tage
   End If

   'Werte Einlesen
   For I = 1 To 100
      Fs_tageswerte(i) = Ee_fs_tageswerte(i)
   Next I

#if Debug_freesol
   For I = 1 To 10
      Print "Tageswerte: " ; Str(i) ; "  " ; Str(fs_tageswerte(i))
   Next I
   Print "Speicherdatum Tage: " ; Str(fs_speicherdatum_tage )
#endif
   Fs_speicherdatum_monate = Ee_fs_speicherdatum_monate
   Fs_monatswerte = Ee_fs_monatswerte
#if Debug_freesol
   Print "Monatswerte Vormonat: " ; Str(fs_monatswerte) ; "  Speicherdatum: " ; Str(fs_speicherdatum_monate )
#endif
   Fs_speicherdat_lfdmon = Ee_fs_speicherdat_lfdmon
   Fs_lfdmonwerte = Ee_fs_lfdmonwerte
#if Debug_freesol
   Print "Monatswerte aktuell: " ; Str(fs_lfdmonwerte) ; "  Speicherdatum: " ; Str(fs_speicherdat_lfdmon )
#endif
End Sub


'*******************************************************************************
'  Freesol-Werte am aktuellen Tag ins Eram speichern
'*******************************************************************************
Sub Fs_eeram_akt_tag_speich
   Local I As Integer
   Local J As Integer
   Local K As Integer
   Local L As Integer
   Local D As Long
   Local D2 As Long
   Local Tag As Long
   Local Wsysday As Word
   Local S As String * 9

    #if System_message > 0
      Print "Routine Eeram aktuellen Tag speichern"
   #endif


   '( Ungetestet. Wird jetzt beim Einlesen gemacht
   ' Prfen, ob letztes Speicherdatum lter als Vortag
   D = Sysday()
   D = D - 1
   If D > Fs_speicherdatum_tage Then
      D2 = Fs_speicherdatum_tage + 1
      For Tag = D2 To D
       L = Tag
       Fs_tageswerte(l) = 0
       Ee_fs_tageswerte(l) = 0
      Next
   End If
')


   ' Den Wert des heutigen Tages am Abend speichern
   Fs_speicherdatum_tage = Sysday()
   Ee_fs_speicherdatum_tage = Fs_speicherdatum_tage
   D = Fs_speicherdatum_tage Mod 100
   I = D
   D = Fs_pulszahl - Fs_stundenstart(1)
   D = D / 10
   Fs_tageswerte(i) = D
   Ee_fs_tageswerte(i) = Fs_tageswerte(i)


   ' Werte des aktuellen Tages lschen
   For J = 1 To 24
      Fs_stundenwerte(j) = 0
      Fs_stundenstart(j) = 0
   Next J
   For J = 1 To 216
      Fs_minw(j) = 0
   Next J


    ' Mail lostreten
   Fs_mail_datum = Date$
   Fs_mail_energie = Fs_tageswerte(i) * 10
   Fs_mail_energienorm = Fs_mail_energie / Fs_anlagenleistung
   Smtp_mail_versand_in = 1
   #if System_message > 0
      Print "Mail_versand_in = " ; Smtp_mail_versand_in ; " Minuten "
   #endif


   ' laufenden Monat speichern
   Fs_lfdmonwerte = 0
   For L = 1 To _day
      K = 101 - L
      K = K + I                                             ' Achtung, I wird von oben bernommen!
      K = K Mod 100
      Fs_lfdmonwerte = Fs_lfdmonwerte + Fs_tageswerte(k)
   Next J
   Fs_lfdmonwerte = Fs_lfdmonwerte * 10
   Fs_speicherdat_lfdmon = Sysday()
   Ee_fs_speicherdat_lfdmon = Fs_speicherdat_lfdmon
   Ee_fs_lfdmonwerte = Fs_lfdmonwerte


    ' Feststellen ob Monatserster
   Tag = Sysday()
   Wsysday = Tag
   Wsysday = Wsysday + 1
   S = Date(wsysday)
   S = Left(s , 2)
   Tag = Val(s)

   If Tag = 1 Then
       ' Falls erster Tag im Monat, dann die zuletzt abgespeicherten Werte des aktuellen Monats als Monatswerte speichern
       Fs_speicherdatum_monate = Fs_speicherdat_lfdmon
       Ee_fs_speicherdatum_monate = Fs_speicherdatum_monate
       Fs_monatswerte = Fs_lfdmonwerte
       Ee_fs_monatswerte = Fs_monatswerte
    End If


End Sub

'*******************************************************************************
'  Freesol-Werte im Eram lschen
'*******************************************************************************
Sub Fs_eeram_loeschen
Local I As Integer
Local Wsysday As Word
Local S As String * 9
Local J As Integer
   Wsysday = Sysday()
   Fs_speicherdatum_tage = 1000
   Fs_speicherdatum_tage = Fs_speicherdatum_tage - 1
   For I = 1 To 100
      Fs_tageswerte(i) = 0
   Next I
   Wsysday = Sysday()
   S = Date(wsysday)
   S = Left(s , 2)
   J = Val(s)
   Fs_speicherdatum_monate = Wsysday - J
   Fs_monatswerte = 0
   Fs_speicherdat_lfdmon = Sysday()
   Fs_speicherdat_lfdmon = Fs_speicherdat_lfdmon - 1
   Fs_lfdmonwerte = 0

   Ee_fs_speicherdatum_tage = Fs_speicherdatum_tage
   #if Debug_freesol
   Print "Speicherdatum Tage geschrieben: " ; Fs_speicherdatum_tage
   #endif
   For I = 1 To 100
      Ee_fs_tageswerte(i) = Fs_tageswerte(i)
   Next I
   Ee_fs_speicherdatum_monate = Fs_speicherdatum_monate
   #if Debug_freesol
      Print "Speicherdatum Monate geschrieben: " ; Fs_speicherdatum_monate
   #endif
   Ee_fs_monatswerte = Fs_monatswerte
   Ee_fs_speicherdat_lfdmon = Fs_speicherdat_lfdmon
   Ee_fs_lfdmonwerte = Fs_lfdmonwerte
   #if Debug_freesol
      Print "Speicherdatum lfdMonat geschrieben: " ; Fs_speicherdat_lfdmon
   #endif
End Sub