unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CPort, JvExControls, JvXPCore, JvXPButtons, StdCtrls, Spin,
  JvExStdCtrls, JvEdit, JvValidateEdit, ComCtrls, JvExComCtrls, JvComCtrls,
  ExtCtrls, JvLED,  JvxSlider, math, shellapi, Grids, ValEdit,
  JvComponent, Winsock;

type TSTringdynarray = array of String;

type
  TForm1 = class(TForm)
    ComPort1: TComPort;
    JvXPButton1: TJvXPButton;
    Bevel1: TBevel;
    LED_RX: TShape;
    Label8: TLabel;
    Label25: TLabel;
    LED_TX: TShape;
    Timer2: TTimer;
    Timer3: TTimer;
    JvXPButton2: TJvXPButton;
    Edit1: TEdit;
    JvXPButton3: TJvXPButton;
    JvXPButton4: TJvXPButton;
    Edit3: TEdit;
    JvXPButton5: TJvXPButton;
    Memo1: TMemo;
    Button1: TButton;
    Label3: TLabel;
    JvIPAddress1: TJvIPAddress;
    Label4: TLabel;
    Label6: TLabel;
    JvIPAddress2: TJvIPAddress;
    Label7: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Label9: TLabel;
    JvIPAddress3: TJvIPAddress;
    Label10: TLabel;
    JvIPAddress4: TJvIPAddress;
    Label11: TLabel;
    JvIPAddress5: TJvIPAddress;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Bevel4: TBevel;
    JvIPAddress6: TJvIPAddress;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Timer1: TTimer;
    JvXPButton6: TJvXPButton;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormShow(Sender: TObject);
    procedure SETUP_COM;
    procedure JvXPButton1Click(Sender: TObject);
    procedure ComPort1RxChar(Sender: TObject; Count: Integer);
    procedure TX_LED_ON;
    procedure RX_LED_ON;
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure sende(Sendstr : string);
    procedure Timer1Timer(Sender: TObject);
    procedure JvXPButton4Click(Sender: TObject);
    procedure JvXPButton5Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    function  STR_TO_IP(IP:String):longword;
    procedure JvIPAddress1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure JvXPButton2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure JvXPButton6Click(Sender: TObject);
    function IP_TO_STR(ip:DWord):string;
    procedure SpinEdit1Click(Sender: TObject);
    procedure SpinEdit1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
    instr : string;
    connected : boolean;
    funktion : integer;
    ready : integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation



{$R *.dfm}



procedure TForm1.FormShow(Sender: TObject);
begin
     ComPort1.LoadSettings(stRegistry, 'HKEY_LOCAL_MACHINE\Software\NETIO');
//     ComPort1.LoadSettings(stIniFile , extractfilepath(application.exename)+'NETIO.ini');
     try
       comport1.Connected := true;
     except
       SETUP_COM;
     end;
     JvXPButton5Click(Self);
     memo1.lines.Clear;
end;


procedure TForm1.SETUP_COM;
begin
        try
             ComPort1.ShowSetupDialog;
             ComPort1.StoreSettings(stRegistry, 'HKEY_LOCAL_MACHINE\Software\NETIO');
//             ComPort1.StoreSettings(stIniFile, extractfilepath(application.exename)+'NETIO.ini');
        except
             showmessage('Kann COM Port nicht starten!');
        end;
end;


procedure TForm1.JvXPButton1Click(Sender: TObject);
begin
        SETUP_COM;
end;

function TForm1.STR_TO_IP(IP:String):longword;
var
    ip_wert : integer;
    ip1,ip2,ip3,ip4 : string;
begin
  if trim(ip) <> '' then begin
    ip1 := copy(ip,1, pos('.',ip)-1);
    IP := copy(IP,pos('.',IP)+1,20);
    ip2 := copy(ip,1, pos('.',ip)-1);
    IP := copy(IP,pos('.',IP)+1,20);
    ip3 := copy(ip,1, pos('.',ip)-1);
    ip4 := copy(IP,pos('.',IP)+1,20);
    result := inet_addr( PChar(ip4+'.'+ip3+'.'+ip2+'.'+ip1));
  end else
    result := 0;
end;

function TForm1.IP_TO_STR(ip:DWord):string;
begin
       IP_TO_STR :=  inttostr(       (ip and 255) )  + '.' +
                     inttostr(trunc( (ip and 65535   ) /  256    )) + '.' +
                     inttostr(trunc( (ip and 16777215) / 65536   )) + '.' +
                     inttostr(trunc(  ip               / 16777216)) ;
end;

procedure TForm1.ComPort1RxChar(Sender: TObject; Count: Integer);
var
        str : string;
        j, code : integer;
        i : dword;
        wert : real;
        a,b, helpstr: string;
begin
   RX_LED_ON;
   ComPort1.ReadStr(Str, Count);

 instr := instr + str;
 while pos(chr(13), instr) > 0 do begin
      helpstr := copy(instr,1,pos(chr(13),instr)-1);
      instr := copy(instr,pos(chr(13),instr)+1, length(instr));
      while copy(helpstr, length(helpstr),1) = chr(13) do begin
          helpstr := copy(helpstr, 1,length(helpstr)-1)
      end;
      while copy(helpstr, length(helpstr),1) = chr(10) do begin
          helpstr := copy(helpstr, 1,length(helpstr)-1)
      end;
      helpstr := StringReplace(helpstr,chr(10),'',[rfreplaceall]);
      a := copy(helpstr, 1,4);
      b := trim(copy(helpstr, 5,length(helpstr)));
      application.processmessages;
      if a = '{50}' then begin //IP           ip2str
                JvIPAddress1.Enabled := true;
                ready := 1;
                Val(b, I, Code);
                if code = 0 then
                   JvIPAddress1.Text := IP_TO_STR(i);
      end else if a = '{51}' then begin  //Subnet
                JvIPAddress2.Enabled := true;
                Val(b, I, Code);
                if code = 0 then
                   JvIPAddress2.Text := IP_TO_STR(i);
      end else if a = '{52}' then begin  //MAC
                edit4.Enabled := true;
                edit4.Text := b;
      end else if a = '{53}' then begin  //Hostname
                edit5.Enabled := true;
                Edit5.Text := b;
      end else if a = '{54}' then begin  //Gateway
                JvIPAddress3.Enabled := true;
                Val(b, I, Code);
                if code = 0 then
                   JvIPAddress3.Text := IP_TO_STR(i);
      end else if a = '{55}' then begin  //DNS
                JvIPAddress4.Enabled := true;
                Val(b, I, Code);
                if code = 0 then
                   JvIPAddress4.Text := IP_TO_STR(i);
      end else if a = '{56}' then begin  //NTP
                JvIPAddress5.Enabled := true;
                if b = '-100' then begin
                    JvIPAddress5.Visible := false;
                    Label12.Visible := false;
                end else begin
                    JvIPAddress5.Visible := true;
                    Label12.Visible := true;
                    Val(b, I, Code);
                    if code = 0 then
                       JvIPAddress5.Text := IP_TO_STR(i);
                end;
      end else if a = '{57}' then begin  //NETIO Nummer
                Edit1.Enabled := true;
                Edit1.Text := b;
      end else if a = '{58}' then begin  //Apache PHP Server
                JvIPAddress6.Enabled := true;
                Val(b, I, Code);
                if code = 0 then
                   JvIPAddress6.Text := IP_TO_STR(i);
      end else if a = '{59}' then begin  //PHP Script
                Edit3.Enabled := true;
                Edit3.Text := b;
      end else if a = '{60}' then begin  //Zeit Ausfhrung PHP Server in Sekunden
                spinedit1.Enabled := true;
                Val(b, I, Code);
                if code = 0 then
                   spinedit1.Value := i;
      end else begin
        if length(memo1.Text) > 10000 then
          memo1.text := '';
        memo1.Lines.add(helpstr);
      end;                                               
   if ready = 7 then                          
      timer1.Enabled := false;
 end;
end;
                                                                            
procedure TForm1.RX_LED_ON;
begin
      LED_RX.Brush.Color := cllime;
      timer3.Enabled := true;
end;                                                   

procedure TForm1.TX_LED_ON;
begin
      LED_TX.Brush.Color := clred;
      timer2.Enabled := true;
end;
                        
                                       
procedure TForm1.Timer2Timer(Sender: TObject);
begin
        timer2.Enabled := false;
        LED_TX.Brush.Color := clmaroon;
        LED_TX.Repaint;
end;

procedure TForm1.Timer3Timer(Sender: TObject);
begin
        timer3.Enabled := false;
        LED_RX.Brush.Color := clgreen;
        LED_RX.Repaint;
        instr := '';
end;

procedure TForm1.sende(Sendstr : string);
begin
     TX_LED_ON;
     application.ProcessMessages;
     if comport1.Connected then begin       
          comport1.WriteStr(trim(sendstr) +chr(13));
     end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
     if (ready and 1) = 0 then begin
        sende('{50}');
        exit;
     end;
end;

procedure TForm1.JvXPButton4Click(Sender: TObject);
begin
//     sende('{03}'+edit3.Text)
end;

procedure TForm1.JvXPButton5Click(Sender: TObject);
begin
        ready := 0;
        timer1.Enabled := true;
        JvIPAddress1.Enabled := false;
        JvIPAddress2.Enabled := false;
        JvIPAddress3.Enabled := false;
        JvIPAddress4.Enabled := false;
        JvIPAddress5.Enabled := false;
        JvIPAddress6.Enabled := false;
        Edit1.Enabled := false;
        Edit3.Enabled := false;
        Edit4.Enabled := false;
        Edit5.Enabled := false;
        spinedit1.Enabled := false;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
        memo1.Text := '';
end;


procedure TForm1.JvIPAddress1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
        if Sender.ClassType =  TJvIPAddress then begin
            (Sender as TJvIPAddress).Tag := 1;
            JvXPButton2.Enabled := true;
        end else if Sender.ClassType =  TEdit then begin
            (Sender as TEdit).Tag := 1;
            JvXPButton2.Enabled := true;
        end else if Sender.ClassType =  TSpinEdit then begin
            (Sender as TSpinEdit).Tag := 1;
            JvXPButton2.Enabled := true;
        end;
end;


procedure TForm1.JvXPButton2Click(Sender: TObject);
var
                                        
  I, Code: Integer;
begin
      if JvIPAddress1.Tag = 1 then begin
         JvIPAddress1.Tag := 0;
         sende('{00}'+stringreplace(JvIPAddress1.Text,'.',chr($2E),[rfreplaceall]));
         sleep(100);
      end;
      if JvIPAddress2.Tag = 1 then begin
         JvIPAddress2.Tag := 0;
         sende('{01}'+stringreplace(JvIPAddress2.Text,'.',chr($2E),[rfreplaceall]));
         sleep(100);
      end;
      if edit4.Tag = 1 then begin
         edit4.Tag := 0;
         edit4.Text := trim(edit4.Text);
         edit4.Text := stringreplace(edit4.text,'-',chr($3A),[rfreplaceall]);
         edit4.Text := stringreplace(edit4.text,',',chr($3A),[rfreplaceall]);
         edit4.Text := stringreplace(edit4.text,'.',chr($3A),[rfreplaceall]);
         edit4.Text := stringreplace(edit4.text,';',chr($3A),[rfreplaceall]);
         edit4.Text := stringreplace(edit4.text,' ',chr($3A),[rfreplaceall]);
         sende('{02}'+edit4.Text);
         sleep(100);
      end;
      if edit5.Tag = 1 then begin
         edit5.Tag := 0;
         sende('{03}'+trim(edit5.Text));
         sleep(100);
      end;
      if JvIPAddress3.Tag = 1 then begin
         JvIPAddress3.Tag := 0;
         sende('{04}'+stringreplace(JvIPAddress3.Text,'.',chr($2E),[rfreplaceall])) ;
         sleep(100);
      end;
      if JvIPAddress4.Tag = 1 then begin
         JvIPAddress4.Tag := 0;
         sende('{05}'+stringreplace(JvIPAddress4.Text,'.',chr($2E),[rfreplaceall])) ;
         sleep(100);
      end;
      if JvIPAddress5.Tag = 1 then begin
         JvIPAddress5.Tag := 0;
         sende('{06}'+stringreplace(JvIPAddress5.Text,'.',chr($2E),[rfreplaceall])) ;
         sleep(100);
      end;


      if Edit1.Tag = 1 then begin
         Edit1.Tag := 0;
         Val(Edit1.Text, I, Code);
         if Code <> 0 then begin
              MessageDlg('Kein gltiger Zahlenwert!', mtWarning, [mbOk], 0);
         end else begin
              sende('{07}'+trim(Edit1.Text));
         end;
         sleep(100);
      end;
      if JvIPAddress6.Tag = 1 then begin
         JvIPAddress6.Tag := 0;
         sende('{08}'+stringreplace(JvIPAddress6.Text,'.',chr($2E),[rfreplaceall]));
         sleep(100);
      end;
      if Edit3.Tag = 1 then begin
         Edit3.Tag := 0;
         sende('{09}'+trim(Edit3.Text));               
         sleep(100);
      end;
      if Spinedit1.Tag = 1 then begin
         Edit3.Tag := 0;
         sende('{10}'+inttostr(spinedit1.Value));
      end;
      JvXPButton2.Enabled := false;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
        if JvXPButton2.Enabled = true then
          if MessageDlg('Save changes?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
            JvXPButton2Click(Self);
end;

procedure TForm1.JvXPButton6Click(Sender: TObject);
begin
        sende('{99}') ;
end;

procedure TForm1.SpinEdit1Click(Sender: TObject);
begin
        if Sender.ClassType =  TJvIPAddress then begin
            (Sender as TJvIPAddress).Tag := 1;
            JvXPButton2.Enabled := true;
        end else if Sender.ClassType =  TEdit then begin
            (Sender as TEdit).Tag := 1;
            JvXPButton2.Enabled := true;
        end else if Sender.ClassType =  TSpinEdit then begin
            (Sender as TSpinEdit).Tag := 1;
            JvXPButton2.Enabled := true;
        end;
end;

procedure TForm1.SpinEdit1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
        if Sender.ClassType =  TJvIPAddress then begin
            (Sender as TJvIPAddress).Tag := 1;
            JvXPButton2.Enabled := true;
        end else if Sender.ClassType =  TEdit then begin
            (Sender as TEdit).Tag := 1;
            JvXPButton2.Enabled := true;
        end else if Sender.ClassType =  TSpinEdit then begin
            (Sender as TSpinEdit).Tag := 1;
            JvXPButton2.Enabled := true;
        end;
end;

end.



